## fped 0.0+r5986

=== Makefile ===
#
# Makefile - Makefile of fped, the footprint editor
#
# Written 2009, 2010 by Werner Almesberger
# Copyright 2009, 2010 by Werner Almesberger
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

PREFIX ?= /usr/local

UPLOAD = werner@sita.openmoko.org:public_html/fped/

OBJS = fped.o expr.o coord.o obj.o delete.o inst.o util.o error.o \
       unparse.o file.o dump.o kicad.o postscript.o meas.o \
       layer.o overlap.o hole.o tsort.o bitset.o \
       cpp.o lex.yy.o y.tab.o \
       gui.o gui_util.o gui_style.o gui_inst.o gui_status.o gui_canvas.o \
       gui_tool.o gui_over.o gui_meas.o gui_frame.o gui_frame_drag.o

XPMS = point.xpm delete.xpm delete_off.xpm \
       vec.xpm frame.xpm \
       line.xpm rect.xpm pad.xpm rpad.xpm hole.xpm arc.xpm circ.xpm \
       meas.xpm meas_x.xpm meas_y.xpm \
       stuff.xpm stuff_off.xpm meas_off.xpm \
       bright.xpm bright_off.xpm all.xpm all_off.xpm

PNGS = intro-1.png intro-2.png intro-3.png intro-4.png intro-5.png \
       intro-6.png concept-inst.png

SHELL = /bin/bash
CFLAGS_GTK = `pkg-config --cflags gtk+-2.0`
LIBS_GTK = `pkg-config --libs gtk+-2.0`

CFLAGS_WARN = -Wall -Wshadow -Wmissing-prototypes \
	      -Wmissing-declarations -Wno-format-zero-length
CFLAGS = -g -std=gnu99 $(CFLAGS_GTK) -DCPP='"cpp"' \
         -DSVN_VERSION='"$(SVN_VERSION)$(SVN_STATUS)"' $(CFLAGS_WARN)
SLOPPY = -Wno-unused -Wno-implicit-function-declaration \
	 -Wno-missing-prototypes -Wno-missing-declarations
LDFLAGS =
LDLIBS = -lm -lfl $(LIBS_GTK)
YACC = bison -y
YYFLAGS = -v

SVN_VERSION:=$(shell svn info -R | sed '/Last Changed Rev: /s///p;d' | \
    sort -r | sed 1q)
SVN_STATUS:=$(shell [ -z "`svn status -q`" ] || echo +)


# ----- Verbosity control -----------------------------------------------------

CPP := $(CPP)   # make sure changing CC won't affect CPP

CC_normal	:= $(CC)
YACC_normal	:= $(YACC)
LEX_normal	:= $(LEX)
DEPEND_normal	:= $(CPP) $(CFLAGS) -MM -MG

CC_quiet	= @echo "  CC       " $@ && $(CC_normal)
YACC_quiet	= @echo "  YACC     " $@ && $(YACC_normal)
LEX_quiet	= @echo "  LEX      " $@ && $(LEX_normal)
GEN_quiet	= @echo "  GENERATE " $@ &&
DEPEND_quiet	= @$(DEPEND_normal)

ifeq ($(V),1)
    CC		= $(CC_normal)
    LEX		= $(LEX_normal)
    YACC	= $(YACC_normal)
    GEN		=
    DEPEND	= $(DEPEND_normal)
else
    CC		= $(CC_quiet)
    LEX		= $(LEX_quiet)
    YACC	= $(YACC_quiet)
    GEN		= $(GEN_quiet)
    DEPEND	= $(DEPEND_quiet)
endif

# ----- Rules -----------------------------------------------------------------

.PHONY:		all dep depend clean spotless
.PHONY:		install uninstall manual upload-manual
.PHONY:		update montage test tests valgrind

.SUFFIXES:	.fig .xpm .ppm

# compile and generate dependencies, based on
# http://scottmcpeak.com/autodepend/autodepend.html

%.o:		%.c
		$(CC) -c $(CFLAGS) $*.c -o $*.o
		$(DEPEND) $*.c | \
		  sed -e \
		    '/^\(.*:\)\? */{p;s///;s/ *\\\?$$/ /;s/  */:\n/g;H;}' \
		    -e '$${g;p;}' -e d >$*.d; \
		  [ "$${PIPESTATUS[*]}" = "0 0" ] || { rm -f $*.d; exit 1; }

# generate 26x26 pixels icons, then drop the 1-pixel frame

.fig.ppm:
		$(GEN) fig2dev -L ppm -Z 0.32 -S 4 $< | \
		  convert -crop 24x24+1+1 - - >$@; \
		  [ "$${PIPESTATUS[*]}" = "0 0" ] || { rm -f $@; exit 1; }

# ppmtoxpm is very chatty, so we suppress its stderr

.ppm.xpm:
		$(GEN) export TMP=_tmp$$$$; ppmcolormask white $< >$$TMP && \
		  ppmtoxpm -name xpm_`basename $@ .xpm` -alphamask $$TMP \
		  $< >$@ 2>/dev/null && rm -f $$TMP || \
		  { rm -f $@ $$TMP; exit 1; }

all:		fped

fped:		$(OBJS)
		$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LDLIBS)

lex.yy.c:	fpd.l y.tab.h
		$(LEX) fpd.l

lex.yy.o:	lex.yy.c y.tab.h
		$(CC) -c $(CFLAGS) $(SLOPPY) lex.yy.c

y.tab.c y.tab.h: fpd.y
		$(YACC) $(YYFLAGS) -d fpd.y

y.tab.o:	y.tab.c
		$(CC) -c $(CFLAGS) $(SLOPPY) y.tab.c

gui_tool.o gui.o: $(XPMS:%=icons/%)

# ----- Upload the GUI manual -------------------------------------------------

manual:		$(XPMS:%=icons/%)
		for n in $(XPMS:%.xpm=%); do \
		    convert icons/$$n.xpm manual/$$n.png || exit 1; done
		fig2dev -L png -S 4 manual/concept-inst.fig \
		    >manual/concept-inst.png

upload-manual:	manual
		scp gui.html README $(UPLOAD)/
		scp $(XPMS:%.xpm=manual/%.png) $(PNGS:%=manual/%) \
		  $(UPLOAD)/manual/

# ----- Debugging help --------------------------------------------------------

montage:
		montage -label %f -frame 3 __dbg????.png png:- | display -

# ----- Dependencies ----------------------------------------------------------

dep depend .depend:
		@echo 'no need to run "make depend" anymore' 1>&2

-include $(OBJS:.o=.d)

# ----- Tests -----------------------------------------------------------------

test tests:	all
		LANG= sh -c \
		  'passed=0 && cd test && \
		  for n in [a-z]*; do \
		  [ $$n != core ] && SCRIPT=$$n CWD_PREFIX=.. . ./$$n; done; \
		  echo "Passed all $$passed tests"'

valgrind:
		VALGRIND="valgrind -q" $(MAKE) tests

# ----- Cleanup ---------------------------------------------------------------

clean:
		rm -f $(OBJS) $(XPMS:%=icons/%) $(XPMS:%.xpm=icons/%.ppm)
		rm -f lex.yy.c y.tab.c y.tab.h y.output .depend $(OBJS:.o=.d)
		rm -f __dbg????.png _tmp* test/core

spotless:	clean
		rm -f fped

# ----- Install / uninstall ---------------------------------------------------

install:	all
		mkdir -p $(DESTDIR)/$(PREFIX)/bin/
		install -m 755 fped $(DESTDIR)/$(PREFIX)/bin/

uninstall:
		rm -f $(DESTDIR)/$(PREFIX)/bin/fped

# ----- SVN update ------------------------------------------------------------

update:
		svn update
		$(MAKE) dep all

=== debian/changelog ===
fped (0.0+r5986-1) unstable; urgency=low

  * Initial release (Closes: #599090).

 -- Xiangfu Liu <xiangfu@sharism.cc>  Mon, 04 Oct 2010 23:27:52 +0800

=== debian/control ===
Source: fped
Section: electronics
Priority: extra
Maintainer: Xiangfu Liu <xiangfu@sharism.cc>
Build-Depends: debhelper (>=  7.4.10), pkg-config, 
	bash (>= 4), flex, bison, 
	imagemagick, transfig, netpbm, ghostscript,
	libgtk2.0-dev 
Standards-Version: 3.9.1
Homepage: http://svn.openmoko.org/trunk/eda/fped

Package: fped
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Footprint editor
 fped is an editor that allows the interactive creation of footprints of
 electronic components. Footprint definitions are stored in a text format
 that resembles a programming language.
 The language is constrained such that anything that can be expressed in
 the textual definition also has a straightforward equivalent operation
 that can be performed through the GUI.
 A description of the GUI can be found here:
 http://people.openmoko.org/werner/fped/gui.html

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PREFIX=/usr

REV=5986
debiandir_SQ = $(subst ','\'',$(dir $(lastword $(MAKEFILE_LIST))))
get-orig-source:
	REV='$(REV)' sh '$(debiandir_SQ)'get-orig-source.sh

override_dh_auto_clean:
	make spotless

%:
	dh $@

=== debian/watch ===
# We track fped svn revisions, thus no need for a watch file.

## fped 0.1+201210

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #
 # Makefile - Makefile of fped, the footprint editor
 #
-# Written 2009, 2010 by Werner Almesberger
-# Copyright 2009, 2010 by Werner Almesberger
+# Written 2009-2012 by Werner Almesberger
+# Copyright 2009-2012 by Werner Almesberger
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -12,10 +12,10 @@
 
 PREFIX ?= /usr/local
 
-UPLOAD = werner@sita.openmoko.org:public_html/fped/
+UPLOAD = www-data@downloads.qi-hardware.com:werner/fped/
 
 OBJS = fped.o expr.o coord.o obj.o delete.o inst.o util.o error.o \
-       unparse.o file.o dump.o kicad.o postscript.o meas.o \
+       unparse.o file.o dump.o kicad.o postscript.o gnuplot.o meas.o \
        layer.o overlap.o hole.o tsort.o bitset.o \
        cpp.o lex.yy.o y.tab.o \
        gui.o gui_util.o gui_style.o gui_inst.o gui_status.o gui_canvas.o \
@@ -32,23 +32,30 @@
        intro-6.png concept-inst.png
 
 SHELL = /bin/bash
+
+CPPFLAGS +=
 CFLAGS_GTK = `pkg-config --cflags gtk+-2.0`
 LIBS_GTK = `pkg-config --libs gtk+-2.0`
 
 CFLAGS_WARN = -Wall -Wshadow -Wmissing-prototypes \
 	      -Wmissing-declarations -Wno-format-zero-length
-CFLAGS = -g -std=gnu99 $(CFLAGS_GTK) -DCPP='"cpp"' \
-         -DSVN_VERSION='"$(SVN_VERSION)$(SVN_STATUS)"' $(CFLAGS_WARN)
+CFLAGS += -g -std=gnu99 $(CFLAGS_GTK) -DCPP='"cpp"' \
+         -DVERSION='"$(GIT_VERSION)$(GIT_STATUS)"' $(CFLAGS_WARN)
 SLOPPY = -Wno-unused -Wno-implicit-function-declaration \
 	 -Wno-missing-prototypes -Wno-missing-declarations
-LDFLAGS =
+LDFLAGS +=
 LDLIBS = -lm -lfl $(LIBS_GTK)
 YACC = bison -y
 YYFLAGS = -v
 
-SVN_VERSION:=$(shell svn info -R | sed '/Last Changed Rev: /s///p;d' | \
-    sort -r | sed 1q)
-SVN_STATUS:=$(shell [ -z "`svn status -q`" ] || echo +)
+GIT_VERSION:=$(shell git rev-parse HEAD | cut -c 1-7)
+GIT_STATUS:=$(shell [ -z "`git status -s -uno`" ] || echo +)
+
+MKDEP = $(DEPEND) $(1).c | \
+	sed -e \
+	'/^\(.*:\)\? */{p;s///;s/ *\\\?$$/ /;s/  */:\n/g;H;}' \
+	  -e '$${g;p;}' -e d >$(1).d; \
+	[ "$${PIPESTATUS[*]}" = "0 0" ] || { rm -f $(1).d; exit 1; }
 
 
 # ----- Verbosity control -----------------------------------------------------
@@ -84,7 +91,7 @@
 
 .PHONY:		all dep depend clean spotless
 .PHONY:		install uninstall manual upload-manual
-.PHONY:		update montage test tests valgrind
+.PHONY:		montage test tests valgrind
 
 .SUFFIXES:	.fig .xpm .ppm
 
@@ -92,12 +99,8 @@
 # http://scottmcpeak.com/autodepend/autodepend.html
 
 %.o:		%.c
-		$(CC) -c $(CFLAGS) $*.c -o $*.o
-		$(DEPEND) $*.c | \
-		  sed -e \
-		    '/^\(.*:\)\? */{p;s///;s/ *\\\?$$/ /;s/  */:\n/g;H;}' \
-		    -e '$${g;p;}' -e d >$*.d; \
-		  [ "$${PIPESTATUS[*]}" = "0 0" ] || { rm -f $*.d; exit 1; }
+		$(CC) $(CPPFLAGS) $(CFLAGS) -c $*.c -o $*.o
+		$(call MKDEP, $*)
 
 # generate 26x26 pixels icons, then drop the 1-pixel frame
 
@@ -124,12 +127,14 @@
 
 lex.yy.o:	lex.yy.c y.tab.h
 		$(CC) -c $(CFLAGS) $(SLOPPY) lex.yy.c
+		$(call MKDEP, lex.yy)
 
 y.tab.c y.tab.h: fpd.y
 		$(YACC) $(YYFLAGS) -d fpd.y
 
 y.tab.o:	y.tab.c
 		$(CC) -c $(CFLAGS) $(SLOPPY) y.tab.c
+		$(call MKDEP, y.tab)
 
 gui_tool.o gui.o: $(XPMS:%=icons/%)
 
@@ -188,9 +193,3 @@
 
 uninstall:
 		rm -f $(DESTDIR)/$(PREFIX)/bin/fped
-
-# ----- SVN update ------------------------------------------------------------
-
-update:
-		svn update
-		$(MAKE) dep all

=== debian/changelog ===
fped (0.1+201210-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs with GCC-10. (Closes: #957224)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 29 Aug 2020 21:32:55 +0100

fped (0.1+201210-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add missing Build-Depends on libfl-dev. (Closes: #846426)

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 04 Apr 2017 18:17:39 +0200

fped (0.1+201210-1) unstable; urgency=low

  * New snapshot, taken from commit d59b472
  * Switched to new project host: http://projects.qi-hardware.com/p/fped
  * debian/rules:
    - include debian buildflags
    - rewrite as a minimal rules file using dh
    - add a get-orig-source target
  * Fix "FTBFS: tsort: cycle: ./Common: line 37:  2851 Aborted"
    This was a "false error" - the regression test is supposed to cause
    fped to abort, which it did, but the shell didn't print "Aborted" on
    that(Debian on Renesas SH(sh4) CPU) platform (Closes: #606536).

 -- Xiangfu Liu <xiangfu@openmobilefree.net>  Mon, 08 Oct 2012 11:38:57 +0800

=== debian/control ===
Source: fped
Section: electronics
Priority: extra
Maintainer: Xiangfu Liu <xiangfu@openmobilefree.net>
Build-Depends: debhelper (>=  7.4.10), dpkg-dev (>= 1.16.1~), pkg-config,
 bash (>= 4), flex, bison, libfl-dev,
 imagemagick, transfig, netpbm, ghostscript,
 libgtk2.0-dev
Standards-Version: 3.9.4
Homepage: http://downloads.qi-hardware.com/people/werner/fped/gui.html
Vcs-Git: git://projects.qi-hardware.com/fped.git

Package: fped
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Footprint editor
 fped is an editor that allows the interactive creation of footprints of
 electronic components. Footprint definitions are stored in a text format
 that resembles a programming language.
 .
 The language is constrained such that anything that can be expressed in
 the textual definition also has a straightforward equivalent operation
 that can be performed through the GUI.
 .
 A description of the GUI can be found here:
 http://downloads.qi-hardware.com/people/werner/fped/gui.html

=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export PREFIX=/usr

%:
	dh $@

override_dh_auto_clean:
	$(MAKE) spotless
	sh debian/clean.sh

override_dh_installchangelogs:
	dpkg-parsechangelog --format rfc822 --all | \
		awk -f debian/changelog.upstream.awk
	dh_installchangelogs debian/changelog.upstream

REPO = git://projects.qi-hardware.com/fped.git
BRANCH = master
get-orig-source:
	REPO='$(REPO)' BRANCH='$(BRANCH)' \
		sh ./debian/get-orig-source.sh
